"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
class IOSNotificationService {
    awaitNotification(npc, notification, timeout) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                let timeoutToken = setTimeout(() => {
                    detachObserver();
                    reject(new Error(`Timeout receiving ${notification} notification.`));
                }, timeout);
                function notificationObserver(_notification) {
                    clearTimeout(timeoutToken);
                    detachObserver();
                    resolve(_notification);
                }
                function detachObserver() {
                    process.nextTick(() => npc.removeObserver(notification, notificationObserver));
                }
                npc.addObserver(notification, notificationObserver);
            });
        });
    }
}
exports.IOSNotificationService = IOSNotificationService;
$injector.register("iOSNotificationService", IOSNotificationService);
